 /* Playfair fixed Temperature Simulated Annealing with flips
    by Michael J. Cowan

    Run with file cipher1.txt       containing cipher
      and         TetraLog_hank.bin containing log tetragraphs
    in same folder as program   */

 #include <algorithm>
 #include <vector>
 #include <iostream>
 #include <condefs.h>
 #include <conio.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <fstream.h>

  char codex[3000],code[2000],alphabet[25],alpha[25];
  char parent[25],ma[25],mot[200];

  int plainex[2000];
  int len,flag,buff,nok,counter,repeat,len_mot,r[30];

  short a[26][26][26][26];

  float e=2.718;
  float parentscore,bestscore,score;
  float ratio,ds,temp,prob,limit;



  trans[8][25] = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24, // norm

                  0,5,10,15,20,1,6,11,16,21,2,7,12,17,22,3,8,13,18,23,4,9,14,19,24,//NW-SE

                  20,21,22,23,24,15,16,17,18,19,10,11,12,13,14,5,6,7,8,9,0,1,2,3,4,//top-bot
                  4,3,2,1,0,9,8,7,6,5,14,13,12,11,10,19,18,17,16,15,24,23,22,21,20 //l to r
                   };


  FILE *InFile;


  void tetragraphs(void);
  void randomise_alpha(void);
  void test_transforms(void);
  void decrypt(void);
  void get_score(void);


 int main()
 {
    int j,k,m,p,t,x;
    int r1,r2,start1,start2,store[5];



     //...load ciphertext....
    p=-1;
    ifstream infile ("cipher1.txt");
    if (!infile) { cout<<"No file!"; getch(); return 0;  }

    while(!infile.eof())
      {
       infile.getline(mot,sizeof(mot));
       len_mot=strlen(mot);
       for(m=0;m<len_mot;m++) {p++;codex[p]=mot[m];}
      } // end while
    infile.close();
    len=strlen(codex);


    strcpy(alphabet,"ABCDEFGHIKLMNOPQRSTUVWXYZ");
    tetragraphs();

    t=-1;
    for(j=0;j<len;j++)
      if(codex[j]>32)
        { t++;code[t]=codex[j]; }
    len=t+1;
    cout<<"length="<<len<<endl;           //getch();
    temp = 10  +  0.087 * (len-84);


     cout<<endl; //getch();

 randomize();    //<<<<-------------------------

 repeat=1;
 bestscore=0;
 while(repeat>0)
 {
     //..shuffle the 25 numbers 0 to 24 inclusive ...
     randomise_alpha();
     //....make parent key....
     for(j=0;j<25;j++) parent[j]=ma[j]=alphabet[r[j]];

     decrypt();
     get_score();
     parentscore=score; counter=0;
     while(counter<50000)
       {

             x=random(50)+1; // nr 1 to ()+1
            
             switch(x)
               {

                case 1: for(m=0;m<25;m++) ma[m]=parent[trans[x][m]]; break;
                case 2: for(m=0;m<25;m++) ma[m]=parent[trans[x][m]]; break;
                case 3: for(m=0;m<25;m++) ma[m]=parent[trans[x][m]]; break;

                case 4: for(m=0;m<25;m++) ma[m]=parent[m];     // swap 2 rows
                        start1=random(5)*5; start2=random(5)*5;
                        for(m=0;m<5;m++) store[m]=ma[start1+m];
                        for(m=0;m<5;m++) ma[start1+m]=ma[start2+m];
                        for(m=0;m<5;m++) ma[start2+m]=store[m];
                        break;
                case 5: for(m=0;m<25;m++) ma[m]=parent[m];   //swap 2 columns
                        start1=random(5); start2=random(5);
                        for(m=0;m<5;m++) store[m]=ma[start1+m*5];
                        for(m=0;m<5;m++) ma[start1+m*5]=ma[start2+m*5];
                        for(m=0;m<5;m++) ma[start2+m*5]=store[m];
                        break;
                default:
                             for(m=0;m<25;m++) ma[m]=parent[m];
                             r1=random(25);
                             do{ r2=random(25); }while(r1==r2);
                             buff=ma[r1];ma[r1]=ma[r2];ma[r2]=buff;
              }




            decrypt();
            get_score();


            ds=score-parentscore;  flag=0;
            if(ds>0) flag=1; //child is better than parent
            else   // ds is negative, so child worse than parent
               {
                ratio=ds/temp;
                prob=pow(e,ratio);
                limit=1+random(1000);limit=limit/1000;
                if(prob>limit) flag=1; // child passes closeness test
               }

            if(flag==1) //child > parent, or is worse but passes closeness test
                      {
                       for(m=0;m<25;m++) parent[m]=ma[m]; // replace parent with child
                       parentscore=score;

                      }
            else counter++;    // key not accepted





       }//end while counter<50000




 }// end while repeat>0




  cout<<endl<<"End ";
  getch();
  return 0;
  }

 /*------------------------------------------------------------------------*/

  void randomise_alpha(void)
   {
      int i,j,Used[30];

      for ( i = 0; i < 25; i++ )  Used[i] = 0;
      for ( i = 0; i < 25; i++ )
          {
            j = rand( ) % 25;

            while ( Used[j] )  j = rand( ) % 25;

            r[i] = j;
            Used[j] = 1;
          }

   }

 void decrypt(void)
  {
    int pos1,pos2,rf,rs,cf,cs,c1,c2,r1,r2,x,y,order[26];
    int j,k,m;

    for(k=0;k<25;k++)
       {x=ma[k]-65; order[x]=k;}


    for(j=0;j<len;j=j+2)
      {
        pos1=order[code[j]-65]; pos2=order[code[j+1]-65];


       rf=pos1/5; rs=pos2/5;   //rf,cf are row & col of first code letter
       cf=pos1%5; cs=pos2%5;

       flag=0;

       if(rf==rs) {            // if same row
          flag=1;
          c1=cf-1;c2=cs-1;     // c1,c2 are columns of 1st & 2nd decodes
          if(c1<0) c1=4;
          if(c2<0) c2=4;
          r1=rf; r2=rs;
         }

        if(cf==cs) {         //  if same column
          flag=1;
          r1=rf-1; r2=rs-1;   // r1,r2 are rows of 1st & 2nd decodes
          if(r1<0) r1=4;
          if(r2<0) r2=4;
          c1=cf; c2=cs;
         }

        if(flag==0) {          // rectangle
          r1=rf;c1=cs;r2=rs;c2=cf;
          }

        pos1=r1*5+c1; pos2=r2*5+c2;
        plainex[j]=ma[pos1]-65;
        plainex[j+1]=ma[pos2]-65;
      }
  }

 void get_score(void)
   {
    int j,m,x,counter;
    char primus;

    counter++;
    if(counter==1000000) {counter=0;cout<<nok/1000000<<", "; }
    x=0; nok++;
    for(j=0;j<len-3;j++)
      x+=a[plainex[j]][plainex[j+1]][plainex[j+2]][plainex[j+3]];
    score=x;

     if(score>bestscore)
        {
          bestscore=score;

          cout<<"nrok="<<nok<<endl;
          cout<<"bestscore="<<bestscore<<"   ";
          for(m=0;m<25;m++) cout<<ma[m]; cout<<endl;
             for(m=0;m<len;m++)
               {primus=plainex[m]+97;cout<<primus;}
         cout<<endl<<endl;
        }

   }

 void tetragraphs(void)
   {
      InFile = fopen( "TetraLog_hank.bin", "rb" );


    fread( a, 2, 456976, InFile );  // read 456976 values, 2 bytes per value, into array a[][][][] from InFile
    fclose( InFile );
    cout<<"Hank's tetragraphs loaded...."<<endl;
   }




